function Tr = calculo_balance_tiempos(D,L,AL,Ttx,Trx)

% Funcin que devuelve el tiempo de subida del enlace
% Criterio general Tr <= 0.35/B, para RZ
%                  Tr <= 0.7/B, para NRZ
% Tr = calculo_balance_tiempos()
%   Tr: tiempo de subida del enlace
%   Ttx: tiempo de subuda del transmisor
%   D: dispersin cromtica (ps/(nm*km))
%   AL: ancho de lnea de la fuente (nm)
%   L: la longitud de la fibra (km)
%   Trx: tiempo de subida del receptor

% Tiempo de subida por dispersin cromtica
Tcd = abs(D)*L*AL*10^3;

Tr = sqrt((Ttx^2)+(Tcd^2)+(Trx^2));