function Lc = calculo_perdidas(N,E,A,D,Lc,Nc,Le,Ne,P);

%La funcin devuelve las prdidas totales del enlace 
%Lc = perdidas(N,A,L,E,Lc,Le,P)
%   Lc: prdidas del enlace (dB)
%   N: nmero de salidas del divisor
%   E: exceso en los divisores (dB)
%   A: atenuacin de la fibra (dB/km)
%   D: longitud de la fibra (km)
%   Lc: prdidas por conector (dB)
%   Nc: nmero de conectores
%   Le: prdidas por empalme (dB)
%   Ne: nmero de empalmes
%   P: penalizacin de potencia (dB)

perdidas_por_distribucion=10*log10(N)+E;
perdidas_de_la_fibra=A*D;
perdidas_de_conectores=Lc*Nc;
perdidas_de_los_empalmes=Le*Ne;
Lc=perdidas_por_distribucion+perdidas_de_la_fibra+perdidas_de_conectores+perdidas_de_los_empalmes+P;

