function configuracion_divisores(valor);

% falta unba condicion cuando hay un divisor por planta

if nargin<1,
    valor= 'comienzo';
end

global DATOS % Variable global que recoge los valores de los controles.
load variables
e1=1;e2=0;e3=0;

if strcmp(valor,'comienzo'),
    
    if distr==1,
        % Estos son los clculos de la distribucin de edificios
        if info_div==1,
            if e>1,
                e1=e;e2=n*v;e3=0;
            elseif e==1,
                e1=n*v;e2=0;e3=0;
            end
        elseif info_div==2,
            if e>1,
                e1=e;e2=n;e3=v;
            elseif e==1,
                e1=n;e2=v;
            end
        end
    elseif distr==0,
        % Estos son los clculos de la distribucin de la urbanizacin
        if e>16
            e1=e/16-mod(e/16,1)+1;
            e2=16;
        else
            e1=e;
        end
    end
    etapas=[e1 e2 e3];
    i=1;
    % Este cdigo hace la transformacin de las salidas de un
    % divisor en un valor que esta en base 2
    %============================================
    while i<4
        if etapas(i)~=0
            if mod(log2(etapas(i)),2)>1,
                d=log2(etapas(i))-mod(log2(etapas(i)),2)+2;
            elseif mod(log2(etapas(i)),2)==0,
                d=log2(etapas(i))-mod(log2(etapas(i)),2);
            else
                d=log2(etapas(i))-mod(log2(etapas(i)),2)+1;
            end
            etapas(i)=2^d;
        end
        i=i+1;
    end
    %============================================
    
    color=[.7 .7 .7];
    % inicializamos los graficos
    set(gcf,'NumberTitle','off','position',[250,250,300,300],'Name','DiseoFTTH', ... 
        'menubar','none','backingstore','off','color',color,'Units','normalized');
    
    uicontrol('style','text','fontsize',10,'units','normalized','position',[.05 .9 .9 .05], ...
        'string','CONFIGURACIN DE LOS DIVISORES','backgroundcolor',[.5 .5 .5]);
    
    uicontrol('style','text','units','normalized','position',[.05 .8 .3 .05], ...
        'string','1 Etapa','backgroundcolor',[.5 .5 .5]);
    
    pr = uicontrol('style','edit','units','normalized','string',etapas(1), ...
        'position',[.4 .8 .15 .05]);
    
    div2x2_1 = uicontrol('style','check','units','normalized','string','Divisores 2x2', ...
        'position',[.6 .8 .3 .05],'backgroundcolor',color);
    
    uicontrol('style','text','units','normalized','position',[.05 .7 .3 .05], ...
        'string','2 Etapa','backgroundcolor',[.5 .5 .5]);
    
    seg = uicontrol('style','edit','units','normalized','string',etapas(2), ...
        'position',[.4 .7 .15 .05]);
    
    div2x2_2 = uicontrol('style','check','units','normalized','string','Divisores 2x2', ...
        'position',[.6 .7 .3 .05],'backgroundcolor',color);
    
    uicontrol('style','text','units','normalized','position',[.05 .6 .3 .05], ...
        'string','3 Etapa','backgroundcolor',[.5 .5 .5]);
    
    ter = uicontrol('style','edit','units','normalized','string',etapas(3), ...
        'position',[.4 .6 .15 .05]);
    
    div2x2_3 = uicontrol('style','check','units','normalized','string','Divisores 2x2', ...
        'position',[.6 .6 .3 .05],'backgroundcolor',color);
    
    uicontrol('style','frame','fontsize',10,'units','normalized','position',[.05 .2 .9 .35], ...
        'backgroundcolor',color);
    
    uicontrol('style','text','units','normalized','position',[.065 .48 .865 .05], ...
        'string','Ratio mximo de divisin','backgroundcolor',[.5 .5 .5]);
    
    bpon=uicontrol('style','radio','units','normalized','position',[.3 .4 .4 .05], ...
        'string','BPON (G.983): 64','backgroundcolor',color,'value',1,...
        'callback','configuracion_divisores(''B'')');
    
    epon=uicontrol('style','radio','units','normalized','position',[.3 .32 .4 .05], ...
        'string','EPON (802.3ah): 16','backgroundcolor',color,...
        'callback','configuracion_divisores(''E'')');
    
    gpon=uicontrol('style','radio','units','normalized','position',[.3 .24 .4 .05], ...
        'string','GPON (G.984): 64','backgroundcolor',color,...
        'callback','configuracion_divisores(''G'')');
    
    uicontrol('Style','Pushbutton','Units','normalized','Position',[.1 .05 .2 .1], ...
              'String','AYUDA','BackgroundColor',color, ...
              'CallBack','configuracion_divisores(''ayuda'')');
    
    uicontrol('Style','Pushbutton','Units','normalized','Position',[.4 .05 .2 .1], ...
              'String','OK','BackgroundColor',color, ...
              'CallBack','configuracion_divisores(''ok'')');
          
    uicontrol('Style','Pushbutton','Units','normalized','Position',[.7 .05 .2 .1], ...
              'String','VOLVER','BackgroundColor',color, ...
              'CallBack','configuracion_divisores(''volver'')');
    
    DATOS=[pr seg ter e1 e2 e3 bpon epon gpon div2x2_1 div2x2_2 div2x2_3];
    
elseif strcmp(valor,'ayuda'),
    msgbox({'En este panel el usuario puede definir los niveles de divisin de las etapas de los divisores.';...
        ' ';...
        'Se permite escoger una configuracin con divisores 2x2. Si el usuario lo desea, cualquiera de las etapas y conservando el nmero de divisiones se implementa con divisores 2x2.';...
        ' ';...
        'En la pantalla aparecen unos valores predeterminados para la estructura definida en el panel anterior. Todos los valores se pueden sustituir si asi lo prefiere el usuario o si las divisiones presentadas por el programa no son correctas. Para saber si dichos valores son correctos, el programa hace una comprobacin de acuerdo con el estndar utilizado'},...
        'Configuracin de los divisores','help');
elseif strcmp(valor,'B'),
    set(DATOS(8),'value',0);
    set(DATOS(9),'value',0);
    pr=str2double(get(DATOS(1),'string'));
    seg=str2double(get(DATOS(2),'string'));
    ter=str2double(get(DATOS(3),'string'));
    if pr>64 || seg>64 || ter>64
        msgbox('El ratio mximo de divisin para BPON es 64','ATENCIN','warn');
    end
elseif strcmp(valor,'E'),
    set(DATOS(7),'value',0);
    set(DATOS(9),'value',0);
    pr=str2double(get(DATOS(1),'string'));
    seg=str2double(get(DATOS(2),'string'));
    ter=str2double(get(DATOS(3),'string'));
    if pr>16 || seg>16 || ter>16
        msgbox('El ratio mximo de divisin para EPON es 16','ATENCIN','warn');
    end
elseif strcmp(valor,'G'),
    set(DATOS(8),'value',0);
    set(DATOS(7),'value',0);
    pr=str2double(get(DATOS(1),'string'));
    seg=str2double(get(DATOS(2),'string'));
    ter=str2double(get(DATOS(3),'string'));
    if pr>64 || seg>64 || ter>64
        msgbox('El ratio mximo de divisin para GPON es 64','ATENCIN','warn');
    end
elseif strcmp(valor,'ok'),
    pr=str2double(get(DATOS(1),'string'));
    seg=str2double(get(DATOS(2),'string'));
    ter=str2double(get(DATOS(3),'string'));
    bp=get(DATOS(7),'value');
    ep=get(DATOS(8),'value');
    gp=get(DATOS(9),'value');
    div2x2_1=get(DATOS(10),'value');
    div2x2_2=get(DATOS(11),'value');
    div2x2_3=get(DATOS(12),'value');
    
    % Los enlaces de cada etapa que quedan libres (enlaces de cada divisor)
    enl1=pr-DATOS(4);
    enl2=seg-DATOS(5);
    enl3=ter-DATOS(6);
    
    if seg~=0 && ter~=0,
        ediv=3;
    elseif seg~=0 && ter==0,
        ediv=2;
    end
    
    if seg==0
        seg=1;ediv=1;
    end
    if ter==0
        ter=1;
    end
    
    info_div=pr*seg*ter;
    save variables distr n v e tramo_largo tramo_corto info_div ediv pr seg ter enl1 enl2 enl3 bp ep gp div2x2_1 div2x2_2 div2x2_3;
    close(gcf);
    principal;
    
elseif strcmp(valor,'volver'),
    if distr==1,
        close(gcf);
        parametros_edificio;
    elseif distr==0,
        close(gcf);
        parametros_urbanizacion;
    end
end