function distribucion(valor)

if nargin<1,
    valor= 'comienzo';
end

global DATOS % variable global que almacena los valores de los controles

if strcmp(valor,'comienzo'),
    
    color=[.7 .7 .7];
    % inicializamos los graficos
    set(gcf,'NumberTitle','off','position',[250,250,390,390],'Name','DiseoFTTH', ... 
        'menubar','none','backingstore','off','color',color,'Units','normalized');
    
    uicontrol('style','text','fontname','book antiqua','fontsize',10,'fontangle','italic', ...
        'string','ELECCIN DE LA DISTRIBUCIN DE LAS VIVIENDAS','units','normalized','position',[.05 .8 .9 .04], ...
        'backgroundcolor',[.5 .5 .5]);
    
    uicontrol('style','frame','units','normalized','position',[.25 .3 .5 .4], ...
        'backgroundcolor',color);
    
    uicontrol('style','text','units','normalized','position',[.3 .6 .4 .04],'string','DISTRIBUCIN', ...
        'backgroundcolor',[.5 .5 .5]);
    
    uicontrol('style','text','units','normalized','position',[.35 .387 .3 .05],'string','BLOQUES DE PISOS', ...
        'backgroundcolor',color,'HorizontalAlignment','left');
    edificios=uicontrol('style','radio','units','normalized','position',[.3 .4 .05 .05], ...
        'backgroundcolor',color,'callback','distribucion(''edif'')');
    
    uicontrol('style','text','units','normalized','position',[.35 .487 .37 .05],'string','RESIDENCIAS INDIVIDUALES', ...
        'backgroundcolor',color,'HorizontalAlignment','left');
    urbanizacion=uicontrol('style','radio','units','normalized','position',[.3 .5 .05 .05],'value',1, ...
        'backgroundcolor',color,'callback','distribucion(''urban'')');
    
    uicontrol('style','pushbutton','units','normalized','position',[.25 .15 .25 .1],'string','OK', ...
        'backgroundcolor',color,'callback','distribucion(''ok'')');
    
    uicontrol('style','pushbutton','units','normalized','position',[.52 .15 .23 .1],'string','SALIR', ...
        'backgroundcolor',color,'callback','distribucion(''salir'')');
    
    % Se guardan los valores de los controles en la variable global
    DATOS = [edificios urbanizacion];
    
elseif strcmp (valor, 'urban'),
    set(DATOS(1),'value',0); % si est marcado el boton de edificios desmarco las residencias 
    
elseif strcmp (valor,'edif'),
    set(DATOS(2),'value',0); % si est marcado el boton de las residencias desmarco edificios

elseif strcmp (valor,'ok'),
    % Cuando pulso el OK se toman todos los datos de los controles
    % almacenados en la variable global y se llama a la funcin
    % correspondiente
    edificios = get(DATOS(1),'value');
    urbanizacion = get(DATOS(2),'value');
    if edificios==1,
        close(gcf);
        parametros_edificio;
    elseif urbanizacion==1,
        close(gcf);
        parametros_urbanizacion;
    end
    
elseif strcmp(valor,'salir'),
    close(gcf);
    clear global DATOS;
    
end