function parametros_urbanizacion(valor)

% Esta es la funcin en la cual definimos los parmetros de una urbanizacin,
% separacin entre las viviendas y se obtiene la longitud del tramo de
% fibra ms largo, que es sobre el cual se realizarn los clculos
% a y b: distancias entre cada casa (m)

if nargin<1,
    valor= 'comienzo';
end

global DATOS % variable global que almacena los valores de los controles
global variables distr n v e tramo_largo tramo_corto info_div ediv pr seg ter ...
    enl1 enl2 enl3 bp ep gp div2x2_1 div2x2_2 div2x2_3 % Estas son variables que almacenan informacin til
                                              % para las gui's siguientes.

if strcmp(valor,'comienzo'),
    
    color=[.7 .7 .7];
    % inicializamos los graficos
    set(gcf,'NumberTitle','off','position',[250,250,390,390],'Name','DiseoFTTH', ... 
        'menubar','none','backingstore','off','color',color,'Units','normalized');
    
    uicontrol('style','text','units','normalized','position',[.05 .93 .9 .04], ...
        'string','PARMETROS DE LA URBANIZACIN','backgroundcolor',[.5 .5 .5]);
    
    axes('units','normalized','position',[.05 .3 .9 .6]);
    [x,map]=imread('dibujo_urbanizacion.png','png');
    image(x);colormap(map);axis off;hold on;
    
    uicontrol('style','text','units','normalized','position',[.05 .23 .37 .04], ...
        'string','a) Distancia (m):','backgroundcolor',color, ...
        'HorizontalAlignment','center');
    a = uicontrol('style','edit','units','normalized','string','25', ...
        'position',[.42 .23 .1 .04]);
    
    uicontrol('style','text','units','normalized','position',[.05 .15 .37 .04], ...
        'string','b) Distancia (m):','backgroundcolor',color, ...
        'HorizontalAlignment','center');
    b = uicontrol('style','edit','units','normalized','string','50', ...
        'position',[.42 .15 .1 .04]);
    
    uicontrol('style','text','units','normalized','position',[.05 .07 .37 .04], ...
        'string','N de viviendas :','backgroundcolor',color, ...
        'HorizontalAlignment','center');
    e = uicontrol('style','edit','units','normalized','string','16', ...
        'position',[.42 .07 .1 .04]);
    
    uicontrol('Style','Pushbutton','Units','normalized','Position',[.7 .18 .15 .05], ...
              'String','OK','BackgroundColor',color, ...
              'CallBack','parametros_urbanizacion(''ok'')');
          
    uicontrol('Style','Pushbutton','Units','normalized','Position',[.7 .08 .15 .05], ...
              'String','VOLVER','BackgroundColor',color, ...
              'CallBack','parametros_urbanizacion(''volver'')');
    
    DATOS=[a b e];% Se almacenan los valores de los controles en la variable global
    
elseif strcmp(valor,'ok'),
    
    % Al pulsar OK, se toman todos los datos introducidos por el usuario,
    % guardados en la variable global y se calcula la longitud de la fibra
    % hasta el hogar que se encuentra ms alejado
    
    a=str2double(get(DATOS(1),'string'));
    b=str2double(get(DATOS(2),'string'));
    e=str2double(get(DATOS(3),'string'));

    distr=0; % Este valor indica que la distribucin utilizada es una urbanizacin
    tramo_largo=((sqrt(e)-1)/2)*(a+b);
    tramo_corto=(a+b)/2;
    n=1; % numero de plantas
    v=1; % numero de vivendas por planta
    if e>16
        info_div=2;
    else 
        info_div=1;
    end
    save variables distr n v e tramo_largo tramo_corto info_div ediv pr seg ter enl1 enl2 enl3 bp ep gp div2x2_1 div2x2_2 div2x2_3;
    close(gcf);
    configuracion_divisores;
    
elseif strcmp(valor,'volver'),
    close(gcf);
    distribucion;
    
end