function principal(valor)

if nargin<1,
    valor= 'comienzo';
end

global DATOS_OLT % variables que almacenan los valores de los controles
global DATOS_ONT
global DATOS_FIBRA
global DATOS_ODN
global DATOS_ESTANDARES
global DATOS_RESULTADOS
global var
load variables % Se cargan las variables de los parametros de los edificios

if strcmp(valor,'comienzo'),
    
    % inicializamos los graficos          %[x_pos y_pos x y]
    set(gcf,'NumberTitle','off','position',[100,100,1190,590],'Name','DiseoFTTH', ... 
        'menubar','none','backingstore','off','color',[0.7 0.7 0.7],'Units','normalized')
     
    textColor=[.7 .7 .7];
    
    % Marco de los parmetros
    uicontrol('Style','frame','Units','normalized','Position',[0.008 0.02 0.43 0.95],...
       'BackgroundColor',textColor);
    
    uicontrol('style','text','units','normalized','fontname','book antiqua','fontsize',15, ...
        'string','PARMETROS DE LOS ELEMENTOS DE LA RED','backgroundcolor',[.5 .5 .5], ...
        'position',[0.02 0.905 0.4 0.04]);
   
    %======================================
    % Definicin de los parmetros del OLT
    %======================================
    
    % Marco del OLT
    uicontrol('Style','frame','Units','normalized','Position',[0.028 0.585 0.185 0.295],...
       'BackgroundColor',textColor);
    
    % Ttulo
    uicontrol('Style','text','units','normalized','string','OLT', ...
        'position',[0.03 0.856 0.181 0.02],'BackgroundColor',[.5 .5 .5]);
    
    % Longitud de onda del Tx
    uicontrol('Style','text','units','normalized','string','Long. de onda de Tx (nm)', ...
        'position',[0.03 0.83 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    londaTx1_OLT=uicontrol('style','edit','units','normalized','position',[0.15 0.829 0.029 0.025], ...
        'HorizontalAlignment','center','string',1490);
    londaTx2_OLT=uicontrol('style','edit','units','normalized','position',[0.18 0.829 0.029 0.025], ...
        'HorizontalAlignment','center','string',1550);
    
    % Longitud de onda del Rx
    uicontrol('Style','text','units','normalized','string','Long. de onda de Rx (nm)', ...
        'position',[0.03 0.8 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    londaRx_OLT=uicontrol('style','edit','units','normalized','position',[0.15 0.8 0.05 0.025], ...
        'HorizontalAlignment','center','string',1310);
    
    % Potencia transmitida
    uicontrol('Style','text','units','normalized','string','Potencia transmitida (dBm)', ...
        'position',[0.03 0.77 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    Ptx_OLT=uicontrol('style','edit','units','normalized','position',[0.15 0.77 0.05 0.025], ...
        'HorizontalAlignment','center','string',0);
    
    % Sensibilidad
    uicontrol('Style','text','units','normalized','string','Sensibilidad (dBm)', ...
        'position',[0.03 0.74 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    sens_OLT=uicontrol('style','edit','units','normalized','position',[0.15 0.74 0.05 0.025], ...
        'HorizontalAlignment','center','string',-30);
    
    % Tiempo de subida
    uicontrol('Style','text','units','normalized','string','Tiempo de subida (ps)', ...
        'position',[0.03 0.71 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    t_subida_OLT=uicontrol('style','edit','units','normalized','position',[0.15 0.71 0.05 0.025], ...
        'HorizontalAlignment','center','string',250);
    
    % Se muestran velocidades tpicas de cada estndar
    if bp==1,
        vel_d=1244;
        vel_u=622;
    elseif ep==1,
        vel_d=1244;
        vel_u=1244;
    elseif gp==1,
        vel_d=2488;
        vel_u=1244;
    end
    
    % RIN
    uicontrol('Style','text','units','normalized','string','RIN (dB/Hz)', ...
        'position',[0.03 0.68 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    RIN_OLT=uicontrol('style','edit','units','normalized','position',[0.15 0.68 0.05 0.025], ...
        'HorizontalAlignment','center','string',-120);
    
    % Ancho espectral de la fuente
    uicontrol('Style','text','units','normalized','string','Ancho esp. de la fte. (nm)', ...
        'position',[0.03 0.65 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    an_es_OLT=uicontrol('style','edit','units','normalized','position',[0.15 0.65 0.05 0.025], ...
        'HorizontalAlignment','center','string',5);
    
    % Relacin de extincin
    uicontrol('Style','text','units','normalized','string','Relacin de extincin (dB)', ...
        'position',[0.03 0.62 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    re_OLT=uicontrol('style','edit','units','normalized','position',[0.15 0.62 0.05 0.025], ...
        'HorizontalAlignment','center','string',10);
    
    % Mxima potencia de entrada
    uicontrol('Style','text','units','normalized','string','Max. pot. de entrada (dBm)', ...
        'position',[0.03 0.59 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    pot_max_OLT=uicontrol('style','edit','units','normalized','position',[0.15 0.59 0.05 0.025], ...
        'HorizontalAlignment','center','string',-14);
    
    %=====================================
    % Definicin de los parmetros del ONT
    %=====================================
    
    sep=.425;
    
    % Marco del ONT
    uicontrol('Style','frame','Units','normalized','Position',[0.028 0.685-sep 0.185 0.295],...
       'BackgroundColor',textColor);
    
    % Ttulo
    uicontrol('Style','text','units','normalized','string','ONT', ...
        'position',[0.03 0.956-sep 0.181 0.02],'BackgroundColor',[.5 .5 .5]);
    
    % Longitud de onda del Tx
    uicontrol('Style','text','units','normalized','string','Long. de onda de Tx (nm)', ...
        'position',[0.03 0.93-sep 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    londaTx_ONT=uicontrol('style','edit','units','normalized','position',[0.15 0.929-sep 0.05 0.025], ...
        'HorizontalAlignment','center','string',1310);
    
    % Longitud de onda del Rx
    uicontrol('Style','text','units','normalized','string','Long. de onda de Rx (nm)', ...
        'position',[0.03 0.9-sep 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    londaRx1_ONT=uicontrol('style','edit','units','normalized','position',[0.15 0.9-sep 0.029 0.025], ...
        'HorizontalAlignment','center','string',1490);
    londaRx2_ONT=uicontrol('style','edit','units','normalized','position',[0.18 0.9-sep 0.029 0.025], ...
        'HorizontalAlignment','center','string',1550);
    
    % Potencia transmitida
    uicontrol('Style','text','units','normalized','string','Potencia transmitida (dBm)', ...
        'position',[0.03 0.87-sep 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    Ptx_ONT=uicontrol('style','edit','units','normalized','position',[0.15 0.87-sep 0.05 0.025], ...
        'HorizontalAlignment','center','string',-4);
    
    % Sensibilidad
    uicontrol('Style','text','units','normalized','string','Sensibilidad (dBm)', ...
        'position',[0.03 0.84-sep 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    sens_ONT=uicontrol('style','edit','units','normalized','position',[0.15 0.84-sep 0.05 0.025], ...
        'HorizontalAlignment','center','string',-28);
    
    % Tiempo de subida
    uicontrol('Style','text','units','normalized','string','Tiempo de subida (ps)', ...
        'position',[0.03 0.81-sep 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    t_subida_ONT=uicontrol('style','edit','units','normalized','position',[0.15 0.81-sep 0.05 0.025], ...
        'HorizontalAlignment','center','string',250);
    
    % RIN
    uicontrol('Style','text','units','normalized','string','RIN (dB/Hz)', ...
        'position',[0.03 0.78-sep 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    RIN_ONT=uicontrol('style','edit','units','normalized','position',[0.15 0.78-sep 0.05 0.025], ...
        'HorizontalAlignment','center','string',-120);
    
    % Ancho espectral de la fuente
    uicontrol('Style','text','units','normalized','string','Ancho esp. de la fte. (nm)', ...
        'position',[0.03 0.75-sep 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    an_es_ONT=uicontrol('style','edit','units','normalized','position',[0.15 0.75-sep 0.05 0.025], ...
        'HorizontalAlignment','center','string',2.8);
    
    % Relacin de extincin
    uicontrol('Style','text','units','normalized','string','Relacin de extincin (dB)', ...
        'position',[0.03 0.72-sep 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    re_ONT=uicontrol('style','edit','units','normalized','position',[0.15 0.72-sep 0.05 0.025], ...
        'HorizontalAlignment','center','string',10);
    
    % Mxima potencia de entrada
    uicontrol('Style','text','units','normalized','string','Max. pot. de entrada (dBm)', ...
        'position',[0.03 0.69-sep 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    pot_max_ONT=uicontrol('style','edit','units','normalized','position',[0.15 0.69-sep 0.05 0.025], ...
        'HorizontalAlignment','center','string',-3);
     
    %========================
    % VELOCIDADES DEL ENLACE
    %========================
    
    % Marco de velocidades
    uicontrol('Style','frame','Units','normalized','Position',[0.028 0.085 0.185 0.13],...
       'BackgroundColor',textColor);
   
    % Ttulo
    uicontrol('Style','text','units','normalized','string','Velocidades', ...
        'position',[0.03 0.1885 0.18 0.022],'BackgroundColor',[.5 .5 .5]);
    
    
    % Tasa binaria de subida
    uicontrol('Style','text','units','normalized','string','Vel. de bajada (Mbps)', ...
        'position',[0.03 0.15 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    tasa_bin_d=uicontrol('style','edit','units','normalized','position',[0.15 0.15 0.05 0.025], ...
        'HorizontalAlignment','center','string',vel_d);
    
    % Tasa binaria de bajada
    uicontrol('Style','text','units','normalized','string','Vel. de subida (Mbps)', ...
        'position',[0.03 0.11 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    tasa_bin_u=uicontrol('style','edit','units','normalized','position',[0.15 0.11 0.05 0.025], ...
        'HorizontalAlignment','center','string',vel_u);
    
    %======================
    % PARMETROS DEL CANAL
    %======================
    
    uicontrol('Style','frame','units','normalized','position',[0.028 0.035 0.385 0.033], ...
       'BackgroundColor',textColor);
    
    % Margen de seguridad
    uicontrol('Style','text','units','normalized','string','Margen de seguridad (dB):', ...
        'position',[0.13 0.039 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    Ms=uicontrol('style','edit','units','normalized','position',[0.25 0.039 0.05 0.025], ...
        'HorizontalAlignment','center','string',3);
    
    %==============
    % FIBRA PTICA
    %==============
    
    % Marco de la fibra
    uicontrol('Style','frame','Units','normalized','Position',[0.228 0.7 0.185 0.18],...
       'BackgroundColor',textColor);
   
    % Ttulo
    uicontrol('Style','text','units','normalized','string','Fibra ptica', ...
        'position',[0.23 0.8535 0.18 0.022],'BackgroundColor',[.5 .5 .5]);
    
    % Longitud total del tramo
    uicontrol('Style','text','units','normalized','string','Dist. del OLT al divisor (km)', ...
        'position',[0.23 0.827 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    long_fibra=uicontrol('style','edit','units','normalized','position',[0.35 0.827 0.05 0.025], ...
        'HorizontalAlignment','center','string',2);
    
    % Atenuaciones
    uicontrol('Style','text','units','normalized','string','Aten.(1310nm) (dB/km)', ...
        'position',[0.23 0.797 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    aten1310=uicontrol('style','edit','units','normalized','position',[0.35 0.797 0.05 0.025], ...
        'HorizontalAlignment','center','string','0.34');
    
    uicontrol('Style','text','units','normalized','string','Aten.(1490nm) (dB/km)', ...
        'position',[0.23 0.767 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    aten1490=uicontrol('style','edit','units','normalized','position',[0.35 0.767 0.05 0.025], ...
        'HorizontalAlignment','center','string','0.24');
    
    uicontrol('Style','text','units','normalized','string','Aten.(1550nm) (dB/km)', ...
        'position',[0.23 0.737 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    aten1550=uicontrol('style','edit','units','normalized','position',[0.35 0.737 0.05 0.025], ...
        'HorizontalAlignment','center','string','0.19');
    
    uicontrol('Style','text','units','normalized','string','Disp. crom. (ns/(nm*km))', ...
        'position',[0.23 0.707 0.115 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    disp=uicontrol('style','edit','units','normalized','position',[0.35 0.707 0.05 0.025], ...
        'HorizontalAlignment','center','string',0.018);
    
    %==========
    % EMPALMES
    %==========
    
    % Marco de empalmes
    uicontrol('Style','frame','Units','normalized','Position',[0.228 0.555 0.185 0.13],...
       'BackgroundColor',textColor);
   
    % Ttulo
    uicontrol('Style','text','units','normalized','string','Empalmes', ...
        'position',[0.23 0.6585 0.18 0.022],'BackgroundColor',[.5 .5 .5]);
    
    % Cantidad
    uicontrol('Style','text','units','normalized','string','Cantidad', ...
        'position',[0.23 0.62 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    nemp=uicontrol('style','edit','units','normalized','position',[0.35 0.62 0.05 0.025], ...
        'HorizontalAlignment','center','string','0');
    
    % Prdidas por empalme
    uicontrol('Style','text','units','normalized','string','Prdidas medias (dB)', ...
        'position',[0.23 0.58 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    aemp=uicontrol('style','edit','units','normalized','position',[0.35 0.58 0.05 0.025], ...
        'HorizontalAlignment','center','string','0.5');
    
    %============
    % CONECTORES
    %============
    
    % Marco de conectores
    uicontrol('Style','frame','Units','normalized','Position',[0.228 0.41 0.185 0.13],...
       'BackgroundColor',textColor);
   
    % Ttulo
    uicontrol('Style','text','units','normalized','string','Conectores', ...
        'position',[0.23 0.5135 0.18 0.022],'BackgroundColor',[.5 .5 .5]);
    
    % Se obtienen el nmero de conectores necesarios para cada etapa en el
    % caso de utilizar divisores 2x2
    var1=0;
    var2=0;
    var3=0;
    if div2x2_1==1,
        var1=log2(pr);
    else 
        if pr~=1
            var1=1;
        end
    end
    if div2x2_2==1,
        var2=log2(seg);
    else 
        if seg~=1
            var2=1;
        end
    end
    if div2x2_3==1,
        var3=log2(ter);
    else 
        if ter~=1
            var3=1;
        end
    end
    if div2x2_1==0 && div2x2_2==0 && div2x2_3==0,
        var=ediv;
    else
        var=var1+var2+var3;
    end
    conectores=2+2*var;
    % Cantidad
    uicontrol('Style','text','units','normalized','string','Cantidad', ...
        'position',[0.23 0.475 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    ncon=uicontrol('style','edit','units','normalized','position',[0.35 0.475 0.05 0.025], ...
        'HorizontalAlignment','center','string',conectores);
    
    % Prdidas por conector
    uicontrol('Style','text','units','normalized','string','Prdidas medias (dB)', ...
        'position',[0.23 0.435 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    acon=uicontrol('style','edit','units','normalized','position',[0.35 0.435 0.05 0.025], ...
        'HorizontalAlignment','center','string','0.5');
    
    %=========
    % DIVISOR
    %=========
    
    % Marco de conectores
    uicontrol('Style','frame','Units','normalized','Position',[0.228 0.25 0.185 0.15],...
       'BackgroundColor',textColor);
   
    % Ttulo
    uicontrol('Style','text','units','normalized','string','Divisor ptico', ...
        'position',[0.23 0.3735 0.18 0.022],'BackgroundColor',[.5 .5 .5]);
    
    % Cantidad
    uicontrol('Style','text','units','normalized','string','Etapas de divisores', ...
        'position',[0.23 0.335 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    et_div=uicontrol('style','edit','units','normalized','position',[0.35 0.335 0.05 0.025], ...
        'HorizontalAlignment','center','string',ediv);
    
    % Niveles de divisin
    uicontrol('Style','text','units','normalized','string','Niveles de divisin 1:', ...
        'position',[0.23 0.3 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    div=uicontrol('style','edit','units','normalized','position',[0.35 0.3 0.05 0.025], ...
        'HorizontalAlignment','center','string',info_div);
    
    % Exceso en los divisores
    uicontrol('Style','text','units','normalized','string','Prdidas de exceso (dB):', ...
        'position',[0.23 0.265 0.11 0.025],'HorizontalAlignment','center', ...
       'BackgroundColor',textColor);
    exc=uicontrol('style','edit','units','normalized','position',[0.35 0.265 0.05 0.025], ...
        'HorizontalAlignment','center','string','1');
    
    %====================
    % ESTNDAR UTILIZADO 
    %====================
    
    uicontrol('Style','frame','Units','normalized','Position',[0.228 0.085 0.185 0.15],...
       'BackgroundColor',textColor);
    uicontrol('Style','text','units','normalized','string','Estndar', ...
        'position',[0.23 0.208 0.18 0.022],'BackgroundColor',[.5 .5 .5]);
    
    % BPON
    bpon=uicontrol('style','radio','units','normalized', ...
        'position',[0.23 0.18 0.1 0.025],'HorizontalAlignment','center',...
        'string','BPON (ITU-T G.983)','BackgroundColor',textColor,'value',bp, ...
        'callback','principal(''B'')');
    
    % EPON
    epon=uicontrol('style','radio','units','normalized', ...
        'position',[0.23 0.14 0.1 0.025],'HorizontalAlignment','center',...
        'string','EPON (IEEE 802.3ah)','BackgroundColor',textColor,'value',ep, ...
        'callback','principal(''E'')');
    
    % GPON
    gpon=uicontrol('style','radio','units','normalized', ...
        'position',[0.23 0.1 0.1 0.025],'HorizontalAlignment','center',...
        'string','GPON (ITU-T G.984)','BackgroundColor',textColor,'value',gp, ...
        'callback','principal(''G'')');
    
    % Clase A
    claseA=uicontrol('style','radio','units','normalized', ...
        'position',[0.35 0.18 0.05 0.025],'HorizontalAlignment','center',...
        'string','Clase A','BackgroundColor',textColor,'value',1, ...
        'callback','principal(''classA'')');
    
    % Clase B
    claseB=uicontrol('style','radio','units','normalized', ...
        'position',[0.35 0.14 0.05 0.025],'HorizontalAlignment','center',...
        'string','Clase B','BackgroundColor',textColor, ...
        'callback','principal(''classB'')');
    
    % Clase C
    claseC=uicontrol('style','radio','units','normalized', ...
        'position',[0.35 0.1 0.05 0.025],'HorizontalAlignment','center',...
        'string','Clase C','BackgroundColor',textColor, ...
        'callback','principal(''classC'')');    
    
    %===================================
    % DEFINICIN DEL ESQUEMA DE LA RED
    %===================================
    
    dibujar(ediv);
    
    uicontrol('Style','text','Units','normalized','Position',[0.47 0.41 0.15 0.025],...
       'BackgroundColor',textColor,'string','Enlaces que quedan libres:');
    
    uicontrol('Style','text','Units','normalized','Position',[0.63 0.41 0.045 0.025],...
       'BackgroundColor',textColor,'string','1 Etapa');
   
    uicontrol('Style','edit','Units','normalized','Position',[0.68 0.41 0.045 0.025],...
        'string',enl1);
    
    uicontrol('Style','text','Units','normalized','Position',[0.73 0.41 0.045 0.025],...
       'BackgroundColor',textColor,'string','2 Etapa');
   
    uicontrol('Style','edit','Units','normalized','Position',[0.78 0.41 0.045 0.025],...
        'string',enl2);
    
    uicontrol('Style','text','Units','normalized','Position',[0.83 0.41 0.045 0.025],...
       'BackgroundColor',textColor,'string','3 Etapa');
   
    uicontrol('Style','edit','Units','normalized','Position',[0.88 0.41 0.045 0.025],...
        'string',enl3);
    
    %==============
    %  RESULTADOS
    %==============
    
    uicontrol('Style','frame','Units','normalized','Position',[0.47 0.13 0.5 0.27],...
       'BackgroundColor',textColor);
   
    uicontrol('Style','text','units','normalized','string','RESULTADOS','fontname','book antiqua',...
        'fontsize',15,'position',[0.48 0.345 0.48 0.04],'BackgroundColor',[.5 .5 .5]);
    
    % Enlace descendente
    uicontrol('Style','frame','Units','normalized','Position',[0.48 0.165 0.237 0.17],...
       'BackgroundColor',textColor);
    uicontrol('Style','text','Units','normalized','Position',[0.483 0.303 0.23 0.025],...
       'BackgroundColor',[.5 .5 .5],'string','Enlace descendente');
    uicontrol('Style','text','Units','normalized','Position',[0.493 0.27 0.12 0.025],...
       'BackgroundColor',textColor,'string','Potencia recibida (dBm) :');
    bpot_down=uicontrol('Style','edit','Units','normalized','Position',[0.65 0.27 0.05 0.025]);
    
    uicontrol('Style','text','Units','normalized','Position',[0.487 0.24 0.145 0.025],...
       'BackgroundColor',textColor,'string','Tiempo de subida del enlace (ps) :');
    bt_down=uicontrol('Style','edit','Units','normalized','Position',[0.65 0.24 0.05 0.025]);
    
    uicontrol('Style','text','Units','normalized','Position',[0.487 0.21 0.145 0.025],...
       'BackgroundColor',textColor,'string','Prdidas del enlace (dB) :');
    perdidas_down=uicontrol('Style','edit','Units','normalized','Position',[0.65 0.21 0.05 0.025]);
    
    resultado_down=uicontrol('Style','edit','Units','normalized','Position',[0.487 0.18 0.22 0.025],...
        'backgroundcolor',textColor);
    
    s=.24;
    
    % Enlace ascendente
    uicontrol('Style','frame','Units','normalized','Position',[0.48+s 0.165 0.233 0.17],...
       'BackgroundColor',textColor);
    uicontrol('Style','text','Units','normalized','Position',[0.483+s 0.303 0.226 0.025],...
       'BackgroundColor',[.5 .5 .5],'string','Enlace ascendente');
    uicontrol('Style','text','Units','normalized','Position',[0.493+s 0.27 0.12 0.025],...
       'BackgroundColor',textColor,'string','Potencia recibida (dBm) :');
    bpot_up=uicontrol('Style','edit','Units','normalized','Position',[0.65+s 0.27 0.05 0.025]);
    
    uicontrol('Style','text','Units','normalized','Position',[0.487+s 0.24 0.145 0.025],...
       'BackgroundColor',textColor,'string','Tiempo de subida del enlace (ps) :');
    bt_up=uicontrol('Style','edit','Units','normalized','Position',[0.65+s 0.24 0.05 0.025]);
    
    uicontrol('Style','text','Units','normalized','Position',[0.487+s 0.21 0.145 0.025],...
       'BackgroundColor',textColor,'string','Prdidas del enlace (dB) :');
    perdidas_up=uicontrol('Style','edit','Units','normalized','Position',[0.65+s 0.21 0.05 0.025]);
    
    resultado_up=uicontrol('Style','edit','Units','normalized','Position',[0.487+s 0.18 0.22 0.025],...
        'backgroundcolor',textColor);
    
    % Tasa binaria mxima recibida por cada usuario
    uicontrol('Style','text','Units','normalized','Position',[0.5 0.136 0.21 0.025],...
       'BackgroundColor',textColor,'string','La tasa binaria mxima recibida por cada usuario:');
    tasa_usuario=uicontrol('Style','edit','Units','normalized','Position',[0.71 0.136 0.04 0.025]);
    uicontrol('Style','text','Units','normalized','Position',[0.75 0.136 0.03 0.025],...
       'BackgroundColor',textColor,'string','(Mbps)');
   
    % Numero total de usuarios
    uicontrol('Style','text','Units','normalized','Position',[0.82 0.136 0.07 0.025],...
       'BackgroundColor',textColor,'string','N usuarios:');
    uicontrol('Style','edit','Units','normalized','Position',[0.9 0.136 0.04 0.025],...
        'string',n*v*e);
   
    % Boton AYUDA
    uicontrol('style','pushbutton','units','normalized', ...
        'position',[0.47 0.05 0.1 0.05],'HorizontalAlignment','center',...
        'string','AYUDA','BackgroundColor',textColor,'callback','principal(''ayuda'')');
    
    % Boton OK
    uicontrol('style','pushbutton','units','normalized', ...
        'position',[0.67 0.05 0.1 0.05],'HorizontalAlignment','center',...
        'string','OK','BackgroundColor',textColor,'callback','principal(''ok'')');
    
    % Boton VOLVER
    uicontrol('style','pushbutton','units','normalized', ...
        'position',[0.87 0.05 0.1 0.05],'HorizontalAlignment','center',...
        'string','VOLVER','BackgroundColor',textColor,'callback','principal(''volver'')');
    
    % Almaceno los valores de todos los controles en sus correspondientes
    % variables
    DATOS_OLT=[londaTx1_OLT londaTx2_OLT londaRx_OLT Ptx_OLT sens_OLT t_subida_OLT ...
         RIN_OLT an_es_OLT re_OLT pot_max_OLT];
    DATOS_ONT=[londaTx_ONT londaRx1_ONT londaRx2_ONT Ptx_ONT sens_ONT t_subida_ONT ...
         RIN_ONT an_es_ONT re_ONT pot_max_ONT];
    DATOS_FIBRA=[long_fibra aten1310 aten1490 aten1550 disp];
    DATOS_ODN=[nemp aemp ncon acon et_div div exc Ms tasa_bin_d tasa_bin_u];
    DATOS_ESTANDARES=[bpon epon gpon claseA claseB claseC];
    DATOS_RESULTADOS=[bpot_down bt_down perdidas_down resultado_down bpot_up bt_up perdidas_up resultado_up tasa_usuario];
    
    % Para que pueda ser marcado tan solo un estndar 
    % Tambien muestra algunas de las velocidades de cada uno
elseif strcmp(valor,'B'),
    set(DATOS_ESTANDARES(2),'value',0);
    set(DATOS_ESTANDARES(3),'value',0);
    set(DATOS_ODN(9),'string',1244);
    set(DATOS_ODN(10),'string',622);
elseif strcmp(valor,'E'),
    set(DATOS_ESTANDARES(1),'value',0);
    set(DATOS_ESTANDARES(3),'value',0);
    set(DATOS_ESTANDARES(4),'value',0);
    set(DATOS_ESTANDARES(5),'value',0);
    set(DATOS_ESTANDARES(6),'value',0);
    set(DATOS_ODN(9),'string',1244);
    set(DATOS_ODN(10),'string',1244);
elseif strcmp(valor,'G'),
    set(DATOS_ESTANDARES(1),'value',0);
    set(DATOS_ESTANDARES(2),'value',0);
    set(DATOS_ODN(9),'string',2488);
    set(DATOS_ODN(10),'string',1244);
    % Para que pueda ser marcado tan solo una clase
elseif strcmp(valor,'classA'),
    set(DATOS_ESTANDARES(5),'value',0);
    set(DATOS_ESTANDARES(6),'value',0);
elseif strcmp(valor,'classB'),
    set(DATOS_ESTANDARES(4),'value',0);
    set(DATOS_ESTANDARES(6),'value',0);
elseif strcmp(valor,'classC'),
    set(DATOS_ESTANDARES(4),'value',0);
    set(DATOS_ESTANDARES(5),'value',0);
       
elseif strcmp(valor,'ayuda'),
    % Al pulsar el boton de ayuda se muestra una ventana explicando los
    % campos de los elementos y el funcionamiento de esta parte de la
    % aplicacin
    msgbox({'En esta parte del programa se permite al usuario definir los parmetros de los elementos utilizados en la red FTTH.';...
        ' ';...
        'Una vez rellenados todos los datos, al pulsar el boton OK, se muestran los resultados obtenidos de los clculos pertinentes para la comprobacin de la viabilidad de la red. Tambien se muestra un croquis de la red mostrando como llega la seal desde el nodo central al abonado.';},...
        'AYUDA','help');
    
elseif strcmp(valor,'ok'),
    
    % Al pulsar OK se toman los datos introducidos por el usuario guardados
    % en las variables correspondientes
    
    londaTx1_OLT=str2double(get(DATOS_OLT(1),'string'));
    londaTx2_OLT=str2double(get(DATOS_OLT(2),'string'));
    londaRx_OLT=str2double(get(DATOS_OLT(3),'string'));
    Ptx_OLT=str2double(get(DATOS_OLT(4),'string'));
    sens_OLT=str2double(get(DATOS_OLT(5),'string'));
    t_subida_OLT=str2double(get(DATOS_OLT(6),'string'));
    RIN_OLT=str2double(get(DATOS_OLT(7),'string'));
    an_es_OLT=str2double(get(DATOS_OLT(8),'string'));
    re_OLT=str2double(get(DATOS_OLT(9),'string'));
    pot_max_OLT=str2double(get(DATOS_OLT(10),'string'));
    
    londaTx_ONT=str2double(get(DATOS_ONT(1),'string'));
    londaRx1_ONT=str2double(get(DATOS_ONT(2),'string'));
    londaRx2_ONT=str2double(get(DATOS_ONT(3),'string'));
    Ptx_ONT=str2double(get(DATOS_ONT(4),'string'));
    sens_ONT=str2double(get(DATOS_ONT(5),'string'));
    t_subida_ONT=str2double(get(DATOS_ONT(6),'string'));
    RIN_ONT=str2double(get(DATOS_ONT(7),'string'));
    an_es_ONT=str2double(get(DATOS_ONT(8),'string'));
    re_ONT=str2double(get(DATOS_ONT(9),'string'));
    pot_max_ONT=str2double(get(DATOS_ONT(10),'string'));
    
    long_fibra=str2double(get(DATOS_FIBRA(1),'string'));
    aten1310=str2double(get(DATOS_FIBRA(2),'string'));
    aten1490=str2double(get(DATOS_FIBRA(3),'string'));
    aten1550=str2double(get(DATOS_FIBRA(4),'string'));
    disp=str2double(get(DATOS_FIBRA(5),'string'));
    
    nemp=str2double(get(DATOS_ODN(1),'string'));
    aemp=str2double(get(DATOS_ODN(2),'string'));
    ncon=str2double(get(DATOS_ODN(3),'string'));
    acon=str2double(get(DATOS_ODN(4),'string'));
    et_div=str2double(get(DATOS_ODN(5),'string'));
    div=str2double(get(DATOS_ODN(6),'string'));
    exc=str2double(get(DATOS_ODN(7),'string'));
    Ms=str2double(get(DATOS_ODN(8),'string'));
    tasa_bin_d=str2double(get(DATOS_ODN(9),'string'));
    tasa_bin_u=str2double(get(DATOS_ODN(10),'string'));
    
    bpon=get(DATOS_ESTANDARES(1),'value');
    epon=get(DATOS_ESTANDARES(2),'value');
    gpon=get(DATOS_ESTANDARES(3),'value');
    claseA=get(DATOS_ESTANDARES(4),'value');
    claseB=get(DATOS_ESTANDARES(5),'value');
    claseC=get(DATOS_ESTANDARES(6),'value');
        
    long1=long_fibra+tramo_largo/1000;
    long2=long_fibra+tramo_corto/1000;
    
    % Si el usuario ha introducido un valor incorrecto en los niveles de
    % divisin del divisor, se rectifica el valor
    if mod(log2(div),2)>1,
        div=log2(div)-mod(log2(div),2)+2;
    elseif mod(log2(div),2)==0,
        div=log2(div)-mod(log2(div),2);
    else
        div=log2(div)-mod(log2(div),2)+1;
    end
    ap=2^div;
    set(DATOS_ODN(6),'string',ap);
    
        
    % Si las velocidades introducidas no coinciden con el estndar
    % utilizado, el programa lo indica mediante una ventana de errror
    if bpon==1,
        BER=10^(-10);
        if long1>20
            msgbox('La distancia mxima entre OLT y ONT para BPON no debe superar los 20 km','ERROR','error');
        end
        if tasa_bin_d~=155 && tasa_bin_d~=622 && tasa_bin_d~=1244,
            msgbox('Las tasas binarias del OLT para BPON solo pueden ser: 155, 622  1244 Mbps','ERROR','error');
        elseif tasa_bin_u~=155 && tasa_bin_u~=622,
            msgbox('Las tasas binarias del ONT para BPON solo pueden ser: 155  622 Mbps','ERROR','error');
        end
    elseif epon==1,
        BER=10^(-12);
        if long1>20
            msgbox('La distancia mxima entre OLT y ONT para EPON no debe superar los 20 km','ERROR','error');
        end
        if tasa_bin_d~=1244,
            msgbox('La tasa binaria del OLT para EPON solo puede ser: 1244 Mbps','ERROR','error');
        elseif tasa_bin_u~=1244,
            msgbox('La tasa binaria del ONT para EPON solo puede ser: 1244 Mbps','ERROR','error');
        end
    elseif gpon==1,
        BER=10^(-10);
        if long2<10 || long1>20
            msgbox('La distancia mxima entre OLT y ONT para GPON debe estar comprendida entre los 10 y los 20 km','ERROR','error');
        end
        if tasa_bin_d~=2488 && tasa_bin_d~=1244,
            msgbox('Las tasas binarias del OLT para GPON solo pueden ser: 1244  2488 Mbps','ERROR','error');
        elseif tasa_bin_u~=155 && tasa_bin_u~=622 && tasa_bin_u~=2488 && tasa_bin_u~=1244,
            msgbox('Las tasas binarias del ONT para GPON solo pueden ser: 155, 622, 1244  2488 Mbps','ERROR','error');
        end
    end

    % Clculo del balance de potencias y de tiempos en el sentido descendente
    % 1490 nm
    P1490_max=calculo_penalizacion(re_OLT,RIN_OLT,BER,(tasa_bin_d/1000),long1,disp,an_es_OLT,1,londaTx1_OLT);
    Lc1490_max=calculo_perdidas(ap,var*exc,aten1490,long1,acon,ncon,aemp,nemp,P1490_max);
    set(DATOS_RESULTADOS(3),'string',calculo_perdidas(ap,var*exc,aten1490,long1,acon,ncon,aemp,nemp,0));
    Pr1490_min=calculo_balance_potencias(Ptx_OLT,Lc1490_max,Ms);
    set(DATOS_RESULTADOS(1),'string',Pr1490_min);

    % ste es el clculo de la potencia mxima que le llegar al
    % usuario ms cercano al divisor
    P1490_min=calculo_penalizacion(re_OLT,RIN_OLT,BER,(tasa_bin_d/1000),long2,disp,an_es_OLT,1,londaTx1_OLT);
    Lc1490_min=calculo_perdidas(ap,var*exc,aten1490,long2,acon,ncon,aemp,nemp,P1490_min);
    Pr1490_max=calculo_balance_potencias(Ptx_OLT,Lc1490_min,Ms);

    % 1550 nm
    P1550=calculo_penalizacion(re_OLT,RIN_OLT,BER,(tasa_bin_d/1000),long1,disp,an_es_OLT,1,londaTx2_OLT);
    Lc1550=calculo_perdidas(ap,var*exc,aten1550,long1,acon,ncon,aemp,nemp,P1550);
    Pr1550=calculo_balance_potencias(Ptx_OLT,Lc1550,Ms);

    Tr_down=calculo_balance_tiempos(disp,long1,an_es_OLT,t_subida_OLT,t_subida_ONT);
    set(DATOS_RESULTADOS(2),'string',Tr_down);

    % Clculo del balance de potencias y de tiempos en el sentido ascendente
    % 1310 nm

    p=1;
    s=1;
    t=1;
    if div2x2_1==1,
        p=pr;
    end
    if div2x2_2==1,
        s=seg;
    end
    if div2x2_3==1,
        t=ter;
    end
    divisiones=p*s*t;

    P1310_max=calculo_penalizacion(re_ONT,RIN_ONT,BER,(tasa_bin_u/1000),long1,0,an_es_ONT,1,londaTx_ONT);
    Lc1310_max=calculo_perdidas(divisiones,var*exc,aten1310,long1,acon,ncon,aemp,nemp,P1310_max);
    set(DATOS_RESULTADOS(7),'string',calculo_perdidas(divisiones,var*exc,aten1310,long1,acon,ncon,aemp,nemp,0));
    Pr1310_min=calculo_balance_potencias(Ptx_ONT,Lc1310_max,Ms);
    set(DATOS_RESULTADOS(5),'string',Pr1310_min);

    % ste es el clculo de la potencia mxima, ya que se considera una
    % distancia de 0 metros entre el usuario y el divisor
    P1310_min=calculo_penalizacion(re_ONT,RIN_ONT,BER,(tasa_bin_u/1000),long2,0,an_es_ONT,1,londaTx_ONT);
    Lc1310_min=calculo_perdidas(divisiones,var*exc,aten1310,long2,acon,ncon,aemp,nemp,P1310_min);
    Pr1310_max=calculo_balance_potencias(Ptx_ONT,Lc1310_min,Ms);

    Tr_up=calculo_balance_tiempos(0,long1,an_es_ONT,t_subida_ONT,t_subida_OLT);
    set(DATOS_RESULTADOS(6),'string',Tr_up);
    num_viv=n*v*e; % numero de abonados
    set(DATOS_RESULTADOS(9),'string',tasa_bin_d/num_viv);

    % Se hacen las comparaciones pertinentes de los resultados para
    % averiguar la viabilidad de los enlaces

    down=1; % El enlace descendente es viable
    up=1; % El enlace ascendente es viable
    bpd=1; % Se cumple el balance de potencias
    bpu=1;
    btd=1; % Se cumple el balance de tiempos
    btu=1;
    maxd=1; % La potencia recibida no sobrepasa el limite
    maxu=1;
    cld=1; % La potencia recibida es la suficiente
    clu=1;
    % Se comprueba si se han cumplido los balances de potencias
    if bpon==1 || gpon==1,
        if claseA==1
            if Lc1490_min<5 || Lc1490_max>20
                cld=0;
            end
            if Lc1310_min<5 || Lc1310_max>20
                clu=0;
            end
        elseif claseB==1,
            if Lc1490_min<10 || Lc1490_max>25
                cld=0;
            end
            if Lc1310_min<10 || Lc1310_max>25
                clu=0;
            end
        elseif claseC==1,
            if Lc1490_min<15 || Lc1490_max>30
                cld=0;
            end
            if Lc1310_min<15 || Lc1310_max>30
                clu=0;
            end    
        end
    elseif epon==1,
        if long1<=10,
            if Lc1490_min<5 || Lc1490_max>19.5
                cld=0;
            end
            if Lc1310_min<5 || Lc1310_max>20
                clu=0;
            end
        elseif long2>10 && long1<=20
            if Lc1490_min<10 || Lc1490_max>23.5
                cld=0;
            end
            if Lc1310_min<10 || Lc1310_max>24
                clu=0;
            end
        end
    end

    % Se comprueba si se cumplen los balances de tiempos
    if (Tr_down*(10^-12))>=(0.7/(tasa_bin_d/1000))
        down=0;btd=0;
    end
    if (Tr_up*(10^-12))>=(0.7/(tasa_bin_u/1000))
        up=0;btu=0;
    end

    % Se comprueba que la potencia recibida no sobrepase la mxima
    % admitida por el receptor
    if Pr1490_max>pot_max_ONT
        maxd=0;
    end
    if Pr1310_max>pot_max_OLT
        maxu=0;
    end

    % Se comprueba que la potencia recibida sea la necesaria para poder
    % ser detectada (balance de potencias)
    if Pr1490_min<sens_ONT
        down=0;bpd=0;
    end
    if Pr1310_min<sens_OLT
        up=0;bpu=0;
    end

    % Finalmente se muestran los resultados en la pantalla
    % Se muestra la viabilidad de la red
    if down==0,
        set(DATOS_RESULTADOS(4),'string','EL ENLACE NO ES VIABLE','backgroundColor',[1 0 0]);
    else
        set(DATOS_RESULTADOS(4),'string','EL ENLACE ES VIABLE','backgroundColor',[0 1 0]);
    end

    if up==0,
        set(DATOS_RESULTADOS(8),'string','EL ENLACE NO ES VIABLE','backgroundColor',[1 0 0]);
    else
        set(DATOS_RESULTADOS(8),'string','EL ENLACE ES VIABLE','backgroundColor',[0 1 0]);
    end
    % Se muestra un mensaje con la condicin que no se cumple y el
    % enlace descendente o ascendente
    if btd==0,
        msgbox('NO SE CUMPLE EL BALANCE DE TIEMPOS','Enlace descendente','warn');
    end
    if btu==0,
        msgbox('NO SE CUMPLE EL BALANCE DE TIEMPOS','Enlace ascendente','warn');
    end
    if bpd==0,
        msgbox('NO SE CUMPLE EL BALANCE DE POTENCIAS','Enlace descendente','warn');
    end
    if bpu==0,
        msgbox('NO SE CUMPLE EL BALANCE DE POTENCIAS','Enlace ascendente','warn');
    end
    if maxd==0,
        msgbox('LA POTENCIA RECIBIDA SOBREPASA LA MXIMA PERMITIDA POR EL RECEPTOR','Enlace descendente','warn');
    end
    if maxu==0,
        msgbox('LA POTENCIA RECIBIDA SOBREPASA LA MXIMA PERMITIDA POR EL RECEPTOR','Enlace ascendente','warn');
    end
    aviso={'LAS PRDIDAS DEL ENLACE NO COINCIDEN CON LA CLASE UTILIZADA';...
            ' ';...
            'BPON/GPON';...
            ' ';...
            '   - Clase A: 5 - 20 dB';...
            ' ';...
            '   - Clase B: 10 - 25 dB';...
            ' ';...
            '   - Clase C: 15 - 30 dB';...
            ' ';...
            'EPON';...
            ' ';...
            '   - Upstream    10 km: 5 - 20 dB';...
            ' ';...
            '                        20 km: 10 - 24 dB';...
            ' ';...
            '   - Downstream: 10 km: 5 - 19.5 dB';...
            ' ';...
            '                           20 km: 10 - 23.5 dB'};
    if cld==0,
        msgbox(aviso,'Enlace descendente','warn');
    end
    if clu==0,
        msgbox(aviso,'Enlace ascendente','warn');
    end


elseif strcmp(valor,'volver'),
    % Al pulsar el boton SALIR, cierra la ventana grfica y borra las variables
    close(gcf);
    clear global DATOS_OLT;
    clear global DATOS_ONT;
    clear global DATOS_FIBRA;
    clear global DATOS_ODN;
    clear global DATOS_ESTANDARES;
    clear global DATOS;
    configuracion_divisores;
    
end